Asterisk.org: Developer Documentation (28 Oct 2009)

Wed Oct 28 15:49:02 2009

## Asterisk developer's documentation

# jitterbuf.c File Reference

jitterbuf: an application-independent jitterbuffer More...

`#include <stdio.h>`
`#include <stdlib.h>`
`#include <string.h>`
`#include "asterisk.h"`
`#include "jitterbuf.h"`

Include dependency graph for jitterbuf.c:

Go to the source code of this file.

## Defines

#define | jb_dbg(...) (dbgf ? dbgf(__VA_ARGS__) : (void)0)
#define | jb_dbg2(...) ((void)0)
#define | jb_err(...) (errf ? errf(__VA_ARGS__) : (void)0)
#define | JB_LONGMAX 2147483647L
#define | JB_LONGMIN (-JB_LONGMAX - 1L)
#define | jb_warn(...) (warnf ? warnf(__VA_ARGS__) : (void)0)

## Functions

static int | _jb_get (jitterbuf *jb, jb_frame *frameout, long now, long interpl)
static jb_frame * | _queue_get (jitterbuf *jb, long ts, int all)
static void | decrement_losspct (jitterbuf *jb)
static void | history_calc_maxbuf (jitterbuf *jb)
static void | history_get (jitterbuf *jb)
static int | history_put (jitterbuf *jb, long ts, long now, long ms)
| simple history manipulation
static void | increment_losspct (jitterbuf *jb)
void | jb_destroy (jitterbuf *jb)
int | jb_get (jitterbuf *jb, jb_frame *frameout, long now, long interpl)
int | jb_getall (jitterbuf *jb, jb_frame *frameout)
int | jb_getinfo (jitterbuf *jb, jb_info *stats)
jitterbuf * | jb_new ()
long | jb_next (jitterbuf *jb)
int | jb_put (jitterbuf *jb, void *data, int type, long ms, long ts, long now)
void | jb_reset (jitterbuf *jb)
int | jb_setconf (jitterbuf *jb, jb_conf *conf)
void | jb_setoutput (jb_output_function_t err, jb_output_function_t warn, jb_output_function_t dbg)
static jb_frame * | queue_get (jitterbuf *jb, long ts)
static jb_frame * | queue_getall (jitterbuf *jb)
static long | queue_last (jitterbuf *jb)
static long | queue_next (jitterbuf *jb)
static int | queue_put (jitterbuf *jb, void *data, int type, long ms, long ts)

## Variables

static jb_output_function_t | dbgf
static jb_output_function_t | errf
static jb_output_function_t | warnf

## Detailed Description

jitterbuf: an application-independent jitterbuffer

Author:
  Steve Kann <stevek@stevek.com>

Definition in file jitterbuf.c.

## Define Documentation

#define jb_dbg | ( | ... |  | ) | (dbgf ? dbgf(__VA_ARGS__) : (void)0)

Definition at line 46 of file jitterbuf.c.

Referenced by _jb_get().

#define jb_dbg2 | ( | ... |  | ) | ((void)0)

Definition at line 51 of file jitterbuf.c.

Referenced by jb_destroy(), jb_new(), and jb_put().

#define jb_err | ( | ... |  | ) | (errf ? errf(__VA_ARGS__) : (void)0)

Definition at line 45 of file jitterbuf.c.

Referenced by queue_put().

#define JB_LONGMAX 2147483647L

define these here, just for ancient compiler systems

Definition at line 41 of file jitterbuf.c.

Referenced by history_calc_maxbuf(), and jb_next().

#define JB_LONGMIN (-JB_LONGMAX - 1L)

Definition at line 42 of file jitterbuf.c.

Referenced by history_calc_maxbuf().

#define jb_warn | ( | ... |  | ) | (warnf ? warnf(__VA_ARGS__) : (void)0)

Definition at line 44 of file jitterbuf.c.

Referenced by history_put(), and jb_get().

## Function Documentation

static int _jb_get | ( | jitterbuf * | jb,
|  | jb_frame * | frameout,
|  | long | now,
|  | long | interpl |
| ) |  |  | `[static]`

Definition at line 539 of file jitterbuf.c.

References jb_info::cnt_contig_interp, jb_info::conf, jb_info::current, decrement_losspct(), jb_info::frames_dropped, jb_info::frames_late, jb_info::frames_lost, jb_info::frames_out, history_get(), increment_losspct(), jitterbuf::info, JB_ADJUST_DELAY, jb_dbg, JB_DROP, JB_INTERP, JB_NOFRAME, JB_OK, JB_TARGET_EXTRA, JB_TYPE_SILENCE, JB_TYPE_VOICE, jb_info::jitter, jb_info::last_adjustment, jb_info::last_voice_ms, jb_conf::max_contig_interp, jb_conf::max_jitterbuf, jb_info::min, jb_frame::ms, jb_info::next_voice_ts, queue_get(), queue_last(), queue_next(), jb_info::silence_begin_ts, jb_info::target, jb_frame::ts, and jb_frame::type.

Referenced by jb_get().

    00540 {
    00541    jb_frame *frame;
    00542    long diff;
    00543    static int dbg_cnt = 0;
    00544
    00545    /*if ((now - jb_next(jb)) > 2 * jb->info.last_voice_ms) jb_warn("SCHED: %ld", (now - jb_next(jb))); */
    00546    /* get jitter info */
    00547    history_get(jb);
    00548
    00549    if (dbg_cnt && dbg_cnt % 50 == 0) {
    00550       jb_dbg("\n");
    00551    }
    00552    dbg_cnt++;
    00553
    00554    /* target */
    00555    jb->info.target = jb->info.jitter + jb->info.min + JB_TARGET_EXTRA;
    00556
    00557    /* if a hard clamp was requested, use it */
    00558    if ((jb->info.conf.max_jitterbuf) && ((jb->info.target - jb->info.min) > jb->info.conf.max_jitterbuf)) {
    00559       jb_dbg("clamping target from %d to %d\n", (jb->info.target - jb->info.min), jb->info.conf.max_jitterbuf);
    00560       jb->info.target = jb->info.min + jb->info.conf.max_jitterbuf;
    00561    }
    00562
    00563    diff = jb->info.target - jb->info.current;
    00564
    00565    /* jb_warn("diff = %d lms=%d last = %d now = %d\n", diff,  */
    00566    /* jb->info.last_voice_ms, jb->info.last_adjustment, now); */
    00567
    00568    /* let's work on non-silent case first */
    00569    if (!jb->info.silence_begin_ts) {
    00570       /* we want to grow */
    00571       if ((diff > 0) &&
    00572          /* we haven't grown in the delay length */
    00573          (((jb->info.last_adjustment + JB_ADJUST_DELAY) < now) ||
    00574          /* we need to grow more than the "length" we have left */
    00575          (diff > queue_last(jb)  - queue_next(jb)) ) ) {
    00576          /* grow by interp frame length */
    00577          jb->info.current += interpl;
    00578          jb->info.next_voice_ts += interpl;
    00579          jb->info.last_voice_ms = interpl;
    00580          jb->info.last_adjustment = now;
    00581          jb->info.cnt_contig_interp++;
    00582          if (jb->info.conf.max_contig_interp && jb->info.cnt_contig_interp >= jb->info.conf.max_contig_interp) {
    00583             jb->info.silence_begin_ts = jb->info.next_voice_ts - jb->info.current;
    00584          }
    00585          jb_dbg("G");
    00586          return JB_INTERP;
    00587       }
    00588
    00589       frame = queue_get(jb, jb->info.next_voice_ts - jb->info.current);
    00590
    00591       /* not a voice frame; just return it. */
    00592       if (frame && frame->type != JB_TYPE_VOICE) {
    00593          if (frame->type == JB_TYPE_SILENCE) {
    00594             jb->info.silence_begin_ts = frame->ts;
    00595             jb->info.cnt_contig_interp = 0;
    00596          }
    00597
    00598          *frameout = *frame;
    00599          jb->info.frames_out++;
    00600          jb_dbg("o");
    00601          return JB_OK;
    00602       }
    00603
    00604
    00605       /* voice frame is later than expected */
    00606       if (frame && frame->ts + jb->info.current < jb->info.next_voice_ts) {
    00607          if (frame->ts + jb->info.current > jb->info.next_voice_ts - jb->info.last_voice_ms) {
    00608             /* either we interpolated past this frame in the last jb_get */
    00609             /* or the frame is still in order, but came a little too quick */
    00610             *frameout = *frame;
    00611             /* reset expectation for next frame */
    00612             jb->info.next_voice_ts = frame->ts + jb->info.current + frame->ms;
    00613             jb->info.frames_out++;
    00614             decrement_losspct(jb);
    00615             jb->info.cnt_contig_interp = 0;
    00616             jb_dbg("v");
    00617             return JB_OK;
    00618          } else {
    00619             /* voice frame is late */
    00620             *frameout = *frame;
    00621             jb->info.frames_out++;
    00622             decrement_losspct(jb);
    00623             jb->info.frames_late++;
    00624             jb->info.frames_lost--;
    00625             jb_dbg("l");
    00626             /*jb_warn("\nlate: wanted=%ld, this=%ld, next=%ld\n", jb->info.next_voice_ts - jb->info.current, frame->ts, queue_next(jb));
    00627             jb_warninfo(jb); */
    00628             return JB_DROP;
    00629          }
    00630       }
    00631
    00632       /* keep track of frame sizes, to allow for variable sized-frames */
    00633       if (frame && frame->ms > 0) {
    00634          jb->info.last_voice_ms = frame->ms;
    00635       }
    00636
    00637       /* we want to shrink; shrink at 1 frame / 500ms */
    00638       /* unless we don't have a frame, then shrink 1 frame */
    00639       /* every 80ms (though perhaps we can shrink even faster */
    00640       /* in this case) */
    00641       if (diff < -JB_TARGET_EXTRA &&
    00642          ((!frame && jb->info.last_adjustment + 80 < now) ||
    00643          (jb->info.last_adjustment + 500 < now))) {
    00644
    00645          jb->info.last_adjustment = now;
    00646          jb->info.cnt_contig_interp = 0;
    00647
    00648          if (frame) {
    00649             *frameout = *frame;
    00650             /* shrink by frame size we're throwing out */
    00651             jb->info.current -= frame->ms;
    00652             jb->info.frames_out++;
    00653             decrement_losspct(jb);
    00654             jb->info.frames_dropped++;
    00655             jb_dbg("s");
    00656             return JB_DROP;
    00657          } else {
    00658             /* shrink by last_voice_ms */
    00659             jb->info.current -= jb->info.last_voice_ms;
    00660             jb->info.frames_lost++;
    00661             increment_losspct(jb);
    00662             jb_dbg("S");
    00663             return JB_NOFRAME;
    00664          }
    00665       }
    00666
    00667       /* lost frame */
    00668       if (!frame) {
    00669          /* this is a bit of a hack for now, but if we're close to
    00670           * target, and we find a missing frame, it makes sense to
    00671           * grow, because the frame might just be a bit late;
    00672           * otherwise, we presently get into a pattern where we return
    00673           * INTERP for the lost frame, then it shows up next, and we
    00674           * throw it away because it's late */
    00675          /* I've recently only been able to replicate this using
    00676           * iaxclient talking to app_echo on asterisk.  In this case,
    00677           * my outgoing packets go through asterisk's (old)
    00678           * jitterbuffer, and then might get an unusual increasing delay
    00679           * there if it decides to grow?? */
    00680          /* Update: that might have been a different bug, that has been fixed..
    00681           * But, this still seemed like a good idea, except that it ended up making a single actual
    00682           * lost frame get interpolated two or more times, when there was "room" to grow, so it might
    00683           * be a bit of a bad idea overall */
    00684          /*if (diff > -1 * jb->info.last_voice_ms) {
    00685             jb->info.current += jb->info.last_voice_ms;
    00686             jb->info.last_adjustment = now;
    00687             jb_warn("g");
    00688             return JB_INTERP;
    00689          } */
    00690          jb->info.frames_lost++;
    00691          increment_losspct(jb);
    00692          jb->info.next_voice_ts += interpl;
    00693          jb->info.last_voice_ms = interpl;
    00694          jb->info.cnt_contig_interp++;
    00695          if (jb->info.conf.max_contig_interp && jb->info.cnt_contig_interp >= jb->info.conf.max_contig_interp) {
    00696             jb->info.silence_begin_ts = jb->info.next_voice_ts - jb->info.current;
    00697          }
    00698          jb_dbg("L");
    00699          return JB_INTERP;
    00700       }
    00701
    00702       /* normal case; return the frame, increment stuff */
    00703       *frameout = *frame;
    00704       jb->info.next_voice_ts += frame->ms;
    00705       jb->info.frames_out++;
    00706       jb->info.cnt_contig_interp = 0;
    00707       decrement_losspct(jb);
    00708       jb_dbg("v");
    00709       return JB_OK;
    00710    } else {
    00711       /* TODO: after we get the non-silent case down, we'll make the
    00712        * silent case -- basically, we'll just grow and shrink faster
    00713        * here, plus handle next_voice_ts a bit differently */
    00714
    00715       /* to disable silent special case altogether, just uncomment this: */
    00716       /* jb->info.silence_begin_ts = 0; */
    00717
    00718       /* shrink interpl len every 10ms during silence */
    00719       if (diff < -JB_TARGET_EXTRA &&
    00720          jb->info.last_adjustment + 10 <= now) {
    00721          jb->info.current -= interpl;
    00722          jb->info.last_adjustment = now;
    00723       }
    00724
    00725       frame = queue_get(jb, now - jb->info.current);
    00726       if (!frame) {
    00727          return JB_NOFRAME;
    00728       } else if (frame->type != JB_TYPE_VOICE) {
    00729          /* normal case; in silent mode, got a non-voice frame */
    00730          *frameout = *frame;
    00731          jb->info.frames_out++;
    00732          return JB_OK;
    00733       }
    00734       if (frame->ts < jb->info.silence_begin_ts) {
    00735          /* voice frame is late */
    00736          *frameout = *frame;
    00737          jb->info.frames_out++;
    00738          decrement_losspct(jb);
    00739          jb->info.frames_late++;
    00740          jb->info.frames_lost--;
    00741          jb_dbg("l");
    00742          /*jb_warn("\nlate: wanted=%ld, this=%ld, next=%ld\n", jb->info.next_voice_ts - jb->info.current, frame->ts, queue_next(jb));
    00743          jb_warninfo(jb); */
    00744          return JB_DROP;
    00745       } else {
    00746          /* voice frame */
    00747          /* try setting current to target right away here */
    00748          jb->info.current = jb->info.target;
    00749          jb->info.silence_begin_ts = 0;
    00750          jb->info.next_voice_ts = frame->ts + jb->info.current + frame->ms;
    00751          jb->info.last_voice_ms = frame->ms;
    00752          jb->info.frames_out++;
    00753          decrement_losspct(jb);
    00754          *frameout = *frame;
    00755          jb_dbg("V");
    00756          return JB_OK;
    00757       }
    00758    }
    00759 }

static jb_frame* _queue_get | ( | jitterbuf * | jb,
|  | long | ts,
|  | int | all |
| ) |  |  | `[static]`

Definition at line 407 of file jitterbuf.c.

References jitterbuf::frames, jb_info::frames_cur, jitterbuf::free, jitterbuf::info, jb_frame::next, jb_frame::prev, and jb_frame::ts.

Referenced by queue_get(), and queue_getall().

    00408 {
    00409    jb_frame *frame;
    00410    frame = jb->frames;
    00411
    00412    if (!frame)
    00413       return NULL;
    00414
    00415    /*jb_warn("queue_get: ASK %ld FIRST %ld\n", ts, frame->ts); */
    00416
    00417    if (all || ts >= frame->ts) {
    00418       /* remove this frame */
    00419       frame->prev->next = frame->next;
    00420       frame->next->prev = frame->prev;
    00421
    00422       if (frame->next == frame)
    00423          jb->frames = NULL;
    00424       else
    00425          jb->frames = frame->next;
    00426
    00427
    00428       /* insert onto "free" single-linked list */
    00429       frame->next = jb->free;
    00430       jb->free = frame;
    00431
    00432       jb->info.frames_cur--;
    00433
    00434       /* we return the frame pointer, even though it's on free list,
    00435        * but caller must copy data */
    00436       return frame;
    00437    }
    00438
    00439    return NULL;
    00440 }

static void decrement_losspct | ( | jitterbuf * | jb | ) | `[static]`

Definition at line 68 of file jitterbuf.c.

References jitterbuf::info, and jb_info::losspct.

Referenced by _jb_get().

    00069 {
    00070    jb->info.losspct = (499 * jb->info.losspct)/500;
    00071 }

static void history_calc_maxbuf | ( | jitterbuf * | jb | ) | `[static]`

Definition at line 205 of file jitterbuf.c.

References jitterbuf::hist_maxbuf, jitterbuf::hist_maxbuf_valid, jitterbuf::hist_minbuf, jitterbuf::hist_ptr, jitterbuf::history, JB_HISTORY_MAXBUF_SZ, JB_HISTORY_SZ, JB_LONGMAX, and JB_LONGMIN.

Referenced by history_get().

    00206 {
    00207    int i,j;
    00208
    00209    if (jb->hist_ptr == 0)
    00210       return;
    00211
    00212
    00213    /* initialize maxbuf/minbuf to the latest value */
    00214    for (i=0;i<JB_HISTORY_MAXBUF_SZ;i++) {
    00215 /*
    00216  * jb->hist_maxbuf[i] = jb->history[(jb->hist_ptr-1) % JB_HISTORY_SZ];
    00217  * jb->hist_minbuf[i] = jb->history[(jb->hist_ptr-1) % JB_HISTORY_SZ];
    00218  */
    00219       jb->hist_maxbuf[i] = JB_LONGMIN;
    00220       jb->hist_minbuf[i] = JB_LONGMAX;
    00221    }
    00222
    00223    /* use insertion sort to populate maxbuf */
    00224    /* we want it to be the top "n" values, in order */
    00225
    00226    /* start at the beginning, or JB_HISTORY_SZ frames ago */
    00227    i = (jb->hist_ptr > JB_HISTORY_SZ) ? (jb->hist_ptr - JB_HISTORY_SZ) : 0;
    00228
    00229    for (;i<jb->hist_ptr;i++) {
    00230       long toins = jb->history[i % JB_HISTORY_SZ];
    00231
    00232       /* if the maxbuf should get this */
    00233       if (toins > jb->hist_maxbuf[JB_HISTORY_MAXBUF_SZ-1])  {
    00234
    00235          /* insertion-sort it into the maxbuf */
    00236          for (j=0;j<JB_HISTORY_MAXBUF_SZ;j++) {
    00237             /* found where it fits */
    00238             if (toins > jb->hist_maxbuf[j]) {
    00239                /* move over */
    00240                memmove(jb->hist_maxbuf+j+1,jb->hist_maxbuf+j, (JB_HISTORY_MAXBUF_SZ-(j+1)) * sizeof(long));
    00241                /* insert */
    00242                jb->hist_maxbuf[j] = toins;
    00243
    00244                break;
    00245             }
    00246          }
    00247       }
    00248
    00249       /* if the minbuf should get this */
    00250       if (toins < jb->hist_minbuf[JB_HISTORY_MAXBUF_SZ-1])  {
    00251
    00252          /* insertion-sort it into the maxbuf */
    00253          for (j=0;j<JB_HISTORY_MAXBUF_SZ;j++) {
    00254             /* found where it fits */
    00255             if (toins < jb->hist_minbuf[j]) {
    00256                /* move over */
    00257                memmove(jb->hist_minbuf+j+1,jb->hist_minbuf+j, (JB_HISTORY_MAXBUF_SZ-(j+1)) * sizeof(long));
    00258                /* insert */
    00259                jb->hist_minbuf[j] = toins;
    00260
    00261                break;
    00262             }
    00263          }
    00264       }
    00265
    00266       if (0) {
    00267          int k;
    00268          fprintf(stderr, "toins = %ld\n", toins);
    00269          fprintf(stderr, "maxbuf =");
    00270          for (k=0;k<JB_HISTORY_MAXBUF_SZ;k++)
    00271             fprintf(stderr, "%ld ", jb->hist_maxbuf[k]);
    00272          fprintf(stderr, "\nminbuf =");
    00273          for (k=0;k<JB_HISTORY_MAXBUF_SZ;k++)
    00274             fprintf(stderr, "%ld ", jb->hist_minbuf[k]);
    00275          fprintf(stderr, "\n");
    00276       }
    00277    }
    00278
    00279    jb->hist_maxbuf_valid = 1;
    00280 }

static void history_get | ( | jitterbuf * | jb | ) | `[static]`

Definition at line 282 of file jitterbuf.c.

References jitterbuf::hist_maxbuf, jitterbuf::hist_maxbuf_valid, jitterbuf::hist_minbuf, jitterbuf::hist_ptr, history_calc_maxbuf(), jitterbuf::info, JB_HISTORY_DROPPCT, JB_HISTORY_MAXBUF_SZ, JB_HISTORY_SZ, jb_info::jitter, and jb_info::min.

Referenced by _jb_get(), jb_getinfo(), and jb_next().

    00283 {
    00284    long max, min, jitter;
    00285    int index;
    00286    int count;
    00287
    00288    if (!jb->hist_maxbuf_valid)
    00289       history_calc_maxbuf(jb);
    00290
    00291    /* count is how many items in history we're examining */
    00292    count = (jb->hist_ptr < JB_HISTORY_SZ) ? jb->hist_ptr : JB_HISTORY_SZ;
    00293
    00294    /* index is the "n"ths highest/lowest that we'll look for */
    00295    index = count * JB_HISTORY_DROPPCT / 100;
    00296
    00297    /* sanity checks for index */
    00298    if (index > (JB_HISTORY_MAXBUF_SZ - 1))
    00299       index = JB_HISTORY_MAXBUF_SZ - 1;
    00300
    00301
    00302    if (index < 0) {
    00303       jb->info.min = 0;
    00304       jb->info.jitter = 0;
    00305       return;
    00306    }
    00307
    00308    max = jb->hist_maxbuf[index];
    00309    min = jb->hist_minbuf[index];
    00310
    00311    jitter = max - min;
    00312
    00313    /* these debug stmts compare the difference between looking at the absolute jitter, and the
    00314     * values we get by throwing away the outliers */
    00315    /*
    00316    fprintf(stderr, "[%d] min=%d, max=%d, jitter=%d\n", index, min, max, jitter);
    00317    fprintf(stderr, "[%d] min=%d, max=%d, jitter=%d\n", 0, jb->hist_minbuf[0], jb->hist_maxbuf[0], jb->hist_maxbuf[0]-jb->hist_minbuf[0]);
    00318    */
    00319
    00320    jb->info.min = min;
    00321    jb->info.jitter = jitter;
    00322 }

static int history_put | ( | jitterbuf * | jb,
|  | long | ts,
|  | long | now,
|  | long | ms |
| ) |  |  | `[static]`

simple history manipulation

Note:
  maybe later we can make the history buckets variable size, or something?

Definition at line 130 of file jitterbuf.c.

References jb_info::cnt_delay_discont, jb_info::conf, jitterbuf::hist_maxbuf, jitterbuf::hist_maxbuf_valid, jitterbuf::hist_ptr, jitterbuf::history, jitterbuf::info, JB_HISTORY_MAXBUF_SZ, JB_HISTORY_SZ, jb_warn, jb_info::jitter, jb_info::last_delay, jb_info::resync_offset, and jb_conf::resync_threshold.

Referenced by jb_put().

    00131 {
    00132    long delay = now - (ts - jb->info.resync_offset);
    00133    long threshold = 2 * jb->info.jitter + jb->info.conf.resync_threshold;
    00134    long kicked;
    00135
    00136    /* don't add special/negative times to history */
    00137    if (ts <= 0)
    00138       return 0;
    00139
    00140    /* check for drastic change in delay */
    00141    if (jb->info.conf.resync_threshold != -1) {
    00142       if (abs(delay - jb->info.last_delay) > threshold) {
    00143          jb->info.cnt_delay_discont++;
    00144          if (jb->info.cnt_delay_discont > 3) {
    00145             /* resync the jitterbuffer */
    00146             jb->info.cnt_delay_discont = 0;
    00147             jb->hist_ptr = 0;
    00148             jb->hist_maxbuf_valid = 0;
    00149
    00150             jb_warn("Resyncing the jb. last_delay %ld, this delay %ld, threshold %ld, new offset %ld\n", jb->info.last_delay, delay, threshold, ts - now);
    00151             jb->info.resync_offset = ts - now;
    00152             jb->info.last_delay = delay = 0; /* after resync, frame is right on time */
    00153          } else {
    00154             return -1;
    00155          }
    00156       } else {
    00157          jb->info.last_delay = delay;
    00158          jb->info.cnt_delay_discont = 0;
    00159       }
    00160    }
    00161
    00162    kicked = jb->history[jb->hist_ptr % JB_HISTORY_SZ];
    00163
    00164    jb->history[(jb->hist_ptr++) % JB_HISTORY_SZ] = delay;
    00165
    00166    /* optimization; the max/min buffers don't need to be recalculated, if this packet's
    00167     * entry doesn't change them.  This happens if this packet is not involved, _and_ any packet
    00168     * that got kicked out of the history is also not involved
    00169     * We do a number of comparisons, but it's probably still worthwhile, because it will usually
    00170     * succeed, and should be a lot faster than going through all 500 packets in history */
    00171    if (!jb->hist_maxbuf_valid)
    00172       return 0;
    00173
    00174    /* don't do this until we've filled history
    00175     * (reduces some edge cases below) */
    00176    if (jb->hist_ptr < JB_HISTORY_SZ)
    00177       goto invalidate;
    00178
    00179    /* if the new delay would go into min */
    00180    if (delay < jb->hist_minbuf[JB_HISTORY_MAXBUF_SZ-1])
    00181       goto invalidate;
    00182
    00183    /* or max.. */
    00184    if (delay > jb->hist_maxbuf[JB_HISTORY_MAXBUF_SZ-1])
    00185       goto invalidate;
    00186
    00187    /* or the kicked delay would be in min */
    00188    if (kicked <= jb->hist_minbuf[JB_HISTORY_MAXBUF_SZ-1])
    00189       goto invalidate;
    00190
    00191    if (kicked >= jb->hist_maxbuf[JB_HISTORY_MAXBUF_SZ-1])
    00192       goto invalidate;
    00193
    00194    /* if we got here, we don't need to invalidate, 'cause this delay didn't
    00195     * affect things */
    00196    return 0;
    00197    /* end optimization */
    00198
    00199
    00200 invalidate:
    00201    jb->hist_maxbuf_valid = 0;
    00202    return 0;
    00203 }

static void increment_losspct | ( | jitterbuf * | jb | ) | `[static]`

Definition at line 63 of file jitterbuf.c.

References jitterbuf::info, and jb_info::losspct.

Referenced by _jb_get().

    00064 {
    00065    jb->info.losspct = (100000 + 499 * jb->info.losspct)/500;
    00066 }

void jb_destroy | ( | jitterbuf * | jb | ) |

Definition at line 100 of file jitterbuf.c.

References free, jitterbuf::free, jb_dbg2, and jb_frame::next.

Referenced by pvt_destructor().

    00101 {
    00102    jb_frame *frame;
    00103    jb_dbg2("jb_destroy(%x)\n", jb);
    00104
    00105    /* free all the frames on the "free list" */
    00106    frame = jb->free;
    00107    while (frame != NULL) {
    00108       jb_frame *next = frame->next;
    00109       free(frame);
    00110       frame = next;
    00111    }
    00112
    00113    /* free ourselves! */
    00114    free(jb);
    00115 }

int jb_get | ( | jitterbuf * | jb,
|  | jb_frame * | frameout,
|  | long | now,
|  | long | interpl |
| ) |  |  |

Definition at line 779 of file jitterbuf.c.

References _jb_get(), jitterbuf::info, JB_DROP, JB_INTERP, JB_OK, jb_warn, jb_info::last_voice_ms, jb_frame::ms, and jb_frame::ts.

Referenced by get_from_jb().

    00780 {
    00781    int ret = _jb_get(jb,frameout,now,interpl);
    00782 #if 0
    00783    static int lastts=0;
    00784    int thists = ((ret == JB_OK) || (ret == JB_DROP)) ? frameout->ts : 0;
    00785    jb_warn("jb_get(%x,%x,%ld) = %d (%d)\n", jb, frameout, now, ret, thists);
    00786    if (thists && thists < lastts) jb_warn("XXXX timestamp roll-back!!!\n");
    00787    lastts = thists;
    00788 #endif
    00789    if(ret == JB_INTERP)
    00790       frameout->ms = jb->info.last_voice_ms;
    00791
    00792    return ret;
    00793 }

int jb_getall | ( | jitterbuf * | jb,
|  | jb_frame * | frameout |
| ) |  |  |

Definition at line 795 of file jitterbuf.c.

References JB_NOFRAME, JB_OK, and queue_getall().

Referenced by complete_transfer(), pvt_destructor(), and schedule_delivery().

    00796 {
    00797    jb_frame *frame;
    00798    frame = queue_getall(jb);
    00799
    00800    if (!frame) {
    00801       return JB_NOFRAME;
    00802    }
    00803
    00804    *frameout = *frame;
    00805    return JB_OK;
    00806 }

int jb_getinfo | ( | jitterbuf * | jb,
|  | jb_info * | stats |
| ) |  |  |

Definition at line 809 of file jitterbuf.c.

References history_get(), jitterbuf::info, and JB_OK.

Referenced by ast_cli_netstats(), construct_rr(), and iax2_show_channels().

    00810 {
    00811
    00812    history_get(jb);
    00813
    00814    *stats = jb->info;
    00815
    00816    return JB_OK;
    00817 }

jitterbuf* jb_new | ( | void |  | ) |

Definition at line 85 of file jitterbuf.c.

References jb_dbg2, jb_reset(), and malloc.

Referenced by new_iax().

    00086 {
    00087    jitterbuf *jb;
    00088
    00089
    00090    jb = malloc(sizeof(jitterbuf));
    00091    if (!jb)
    00092       return NULL;
    00093
    00094    jb_reset(jb);
    00095
    00096    jb_dbg2("jb_new() = %x\n", jb);
    00097    return jb;
    00098 }

long jb_next | ( | jitterbuf * | jb | ) |

Definition at line 761 of file jitterbuf.c.

References jb_info::current, jitterbuf::frames, history_get(), jitterbuf::info, JB_LONGMAX, JB_TARGET_EXTRA, jb_info::last_adjustment, jb_info::next_voice_ts, queue_next(), jb_info::silence_begin_ts, and jb_info::target.

Referenced by get_from_jb(), and update_jbsched().

    00762 {
    00763    if (jb->info.silence_begin_ts) {
    00764       if (jb->frames) {
    00765          long next = queue_next(jb);
    00766          history_get(jb);
    00767          /* shrink during silence */
    00768          if (jb->info.target - jb->info.current < -JB_TARGET_EXTRA)
    00769             return jb->info.last_adjustment + 10;
    00770          return next + jb->info.target;
    00771       }
    00772       else
    00773          return JB_LONGMAX;
    00774    } else {
    00775       return jb->info.next_voice_ts;
    00776    }
    00777 }

int jb_put | ( | jitterbuf * | jb,
|  | void * | data,
|  | int | type,
|  | long | ms,
|  | long | ts,
|  | long | now |
| ) |  |  |

Definition at line 518 of file jitterbuf.c.

References jb_info::frames_in, history_put(), jitterbuf::info, jb_dbg2, JB_DROP, JB_OK, JB_SCHED, JB_TYPE_VOICE, and queue_put().

Referenced by schedule_delivery().

    00519 {
    00520    jb_dbg2("jb_put(%x,%x,%ld,%ld,%ld)\n", jb, data, ms, ts, now);
    00521
    00522    jb->info.frames_in++;
    00523
    00524    if (type == JB_TYPE_VOICE) {
    00525       /* presently, I'm only adding VOICE frames to history and drift calculations; mostly because with the
    00526        * IAX integrations, I'm sending retransmitted control frames with their awkward timestamps through */
    00527       if (history_put(jb,ts,now,ms))
    00528          return JB_DROP;
    00529    }
    00530
    00531    /* if put into head of queue, caller needs to reschedule */
    00532    if (queue_put(jb,data,type,ms,ts)) {
    00533       return JB_SCHED;
    00534    }
    00535    return JB_OK;
    00536 }

void jb_reset | ( | jitterbuf * | jb | ) |

Definition at line 73 of file jitterbuf.c.

References jb_info::conf, jb_info::current, jitterbuf::info, JB_TARGET_EXTRA, s, jb_info::silence_begin_ts, and jb_info::target.

Referenced by complete_transfer(), jb_new(), and schedule_delivery().

    00074 {
    00075    /* only save settings */
    00076    jb_conf s = jb->info.conf;
    00077    memset(jb,0,sizeof(jitterbuf));
    00078    jb->info.conf = s;
    00079
    00080    /* initialize length */
    00081    jb->info.current = jb->info.target = JB_TARGET_EXTRA;
    00082    jb->info.silence_begin_ts = -1;
    00083 }

int jb_setconf | ( | jitterbuf * | jb,
|  | jb_conf * | conf |
| ) |  |  |

Definition at line 819 of file jitterbuf.c.

References jb_info::conf, jitterbuf::info, JB_OK, jb_conf::max_contig_interp, jb_conf::max_jitterbuf, and jb_conf::resync_threshold.

Referenced by new_iax().

    00820 {
    00821    /* take selected settings from the struct */
    00822
    00823    jb->info.conf.max_jitterbuf = conf->max_jitterbuf;
    00824    jb->info.conf.resync_threshold = conf->resync_threshold;
    00825    jb->info.conf.max_contig_interp = conf->max_contig_interp;
    00826
    00827    return JB_OK;
    00828 }

void jb_setoutput | ( | jb_output_function_t | err,
|  | jb_output_function_t | warn,
|  | jb_output_function_t | dbg |
| ) |  |  |

Definition at line 56 of file jitterbuf.c.

Referenced by iax2_do_jb_debug(), iax2_no_jb_debug(), and load_module().

    00057 {
    00058    errf = err;
    00059    warnf = warn;
    00060    dbgf = dbg;
    00061 }

static jb_frame* queue_get | ( | jitterbuf * | jb,
|  | long | ts |
| ) |  |  | `[static]`

Definition at line 442 of file jitterbuf.c.

References _queue_get().

Referenced by _jb_get().

    00443 {
    00444    return _queue_get(jb,ts,0);
    00445 }

static jb_frame* queue_getall | ( | jitterbuf * | jb | ) | `[static]`

Definition at line 447 of file jitterbuf.c.

References _queue_get().

Referenced by jb_getall().

    00448 {
    00449    return _queue_get(jb,0,1);
    00450 }

static long queue_last | ( | jitterbuf * | jb | ) | `[static]`

Definition at line 399 of file jitterbuf.c.

References jitterbuf::frames, jb_frame::prev, and jb_frame::ts.

Referenced by _jb_get().

    00400 {
    00401    if (jb->frames)
    00402       return jb->frames->prev->ts;
    00403    else
    00404       return -1;
    00405 }

static long queue_next | ( | jitterbuf * | jb | ) | `[static]`

Definition at line 391 of file jitterbuf.c.

References jitterbuf::frames, and jb_frame::ts.

Referenced by _jb_get(), and jb_next().

    00392 {
    00393    if (jb->frames)
    00394       return jb->frames->ts;
    00395    else
    00396       return -1;
    00397 }

static int queue_put | ( | jitterbuf * | jb,
|  | void * | data,
|  | int | type,
|  | long | ms,
|  | long | ts |
| ) |  |  | `[static]`

Definition at line 325 of file jitterbuf.c.

References jb_frame::data, frames, jitterbuf::frames, jb_info::frames_cur, jb_info::frames_ooo, jitterbuf::free, jitterbuf::info, jb_err, malloc, jb_frame::ms, jb_frame::next, jb_frame::prev, jb_info::resync_offset, jb_frame::ts, and jb_frame::type.

Referenced by jb_put().

    00326 {
    00327    jb_frame *frame;
    00328    jb_frame *p;
    00329    int head = 0;
    00330    long resync_ts = ts - jb->info.resync_offset;
    00331
    00332    frame = jb->free;
    00333    if (frame) {
    00334       jb->free = frame->next;
    00335    } else {
    00336       frame = malloc(sizeof(jb_frame));
    00337    }
    00338
    00339    if (!frame) {
    00340       jb_err("cannot allocate frame\n");
    00341       return 0;
    00342    }
    00343
    00344    jb->info.frames_cur++;
    00345
    00346    frame->data = data;
    00347    frame->ts = resync_ts;
    00348    frame->ms = ms;
    00349    frame->type = type;
    00350
    00351    /*
    00352     * frames are a circular list, jb-frames points to to the lowest ts,
    00353     * jb->frames->prev points to the highest ts
    00354     */
    00355
    00356    if (!jb->frames) {  /* queue is empty */
    00357       jb->frames = frame;
    00358       frame->next = frame;
    00359       frame->prev = frame;
    00360       head = 1;
    00361    } else if (resync_ts < jb->frames->ts) {
    00362       frame->next = jb->frames;
    00363       frame->prev = jb->frames->prev;
    00364
    00365       frame->next->prev = frame;
    00366       frame->prev->next = frame;
    00367
    00368       /* frame is out of order */
    00369       jb->info.frames_ooo++;
    00370
    00371       jb->frames = frame;
    00372       head = 1;
    00373    } else {
    00374       p = jb->frames;
    00375
    00376       /* frame is out of order */
    00377       if (resync_ts < p->prev->ts) jb->info.frames_ooo++;
    00378
    00379       while (resync_ts < p->prev->ts && p->prev != jb->frames)
    00380          p = p->prev;
    00381
    00382       frame->next = p;
    00383       frame->prev = p->prev;
    00384
    00385       frame->next->prev = frame;
    00386       frame->prev->next = frame;
    00387    }
    00388    return head;
    00389 }

## Variable Documentation

jb_output_function_t dbgf`[static]`

Definition at line 54 of file jitterbuf.c.

jb_output_function_t errf`[static]`

Definition at line 54 of file jitterbuf.c.

jb_output_function_t warnf`[static]`

Definition at line 54 of file jitterbuf.c.